datablock ParticleData(PlasmaCDebrisParticle)
{
      dragCoefficient      = 3;
      gravityCoefficient   = -0.8;
      inheritedVelFactor   = 0.15;
      constantAcceleration = 0.0;
      lifetimeMS           = 1500;
      lifetimeVarianceMS   = 1000;
      textureName          = "base/data/particles/cloud";
      spinSpeed		= 10.0;
      spinRandomMin		= -150.0;
      spinRandomMax		= 150.0;
      colors[0]     = "0.1 0.6 1 0.9";
      colors[1]     = "0.1 0.6 1 0.8";
      colors[2]     = "0.1 0.6 1 0.5";
      colors[3]     = "0.1 0.6 1 0.2";

      sizes[0]      = 1.8;
      sizes[1]      = 1.4;
      sizes[2]      = 1.2;
      sizes[3]      = 0.8;

      times[0] = 0.0;
      times[1] = 0.15;
      times[2] = 0.4;
      times[3] = 1.0;

      useInvAlpha = false;
};

datablock ParticleEmitterData(PlasmaCDebrisEmitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;
   ejectionVelocity = 0.0;
   ejectionOffset   = 0.0;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;

   lifetimeMS = 5000;
   particles = PlasmaCDebrisParticle;   
};

datablock DebrisData(PlasmaCExplosionDebris1)
{
   shapeFile = "Base/data/shapes/empty.dts";

   texture = "base/data/particles/dot";
   render2D = false;
   emitters[0] = "PlasmaCDebrisEmitter";
   //explosion = PlasmaCExplosion;
   elasticity = 0.50;
   friction = 0.5;
   numBounces = 1;
   bounceVariance = 0;
   explodeOnMaxBounce = False;
   staticOnMaxBounce = True;
   snapOnMaxBounce = False;

   minSpinSpeed = -500;
   maxSpinSpeed = 500;
   lifetime = 5;
   lifetimeVariance = 2;
   velocity = 15;

   velocityVariance = 0;
   fade = false;
   useRadiusMass = False;
   baseRadius = 1.0;

   gravModifier = 1;

   terminalVelocity = 100;
   ignoreWater = True;                                          
};
datablock AudioProfile(PlasmaCShot1Sound)
{
   filename    = "./PlasmaCShot1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(PlasmaCHit2Sound)
{
   filename    = "./PlasmaCHit2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock ParticleData(PlasmaCExplosionParticle)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1010;
   lifetimeVarianceMS   = 400;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.1 0.6 1 0.9";
   colors[1]     = "0.1 0.6 1 0.8";
   colors[2]     = "0.1 0.6 1 0.5";
   colors[3]     = "0.1 0.6 1 0.2";

   sizes[0]      = 3.0;
   sizes[1]      = 4.0;
   sizes[2]      = 5.0;
   sizes[3]      = 6.5;

   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaCExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaCExplosionParticle";
};

datablock ParticleData(PlasmaCExplosionBParticle)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 200;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.1 0.6 1 0.9";
   colors[1]     = "0.1 0.6 1 0.8";
   colors[2]     = "0.1 0.6 1 0.5";
   colors[3]     = "0.1 0.6 1 0.2";

   sizes[0]      = 0.5;
   sizes[1]      = 0.7;
   sizes[2]      = 1.5;
   sizes[3]      = 1.75;

   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaCExplosionBEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaCExplosionBParticle";
};

datablock ParticleData(PlasmaCExplosionRingBParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 100;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0.1 0.6 1 0.9";
   colors[1]     = "0.1 0.6 1 0.8";
   colors[2]     = "0.1 0.6 1 0.5";
   colors[3]     = "0.1 0.6 1 0.2";

   sizes[0]      = 0.5;
   sizes[1]      = 0.8;
   sizes[2]      = 0.5;
   sizes[3]      = 1.5;

   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaCExplosionRingBEmitter)
{
   lifetimeMS = 60;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.5;
   thetaMin         = 89;
   thetaMax         = 91;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaCExplosionRingBParticle";
};

datablock ParticleData(PlasmaCExplosionRingParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 100;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "0.1 0.6 1 0.9";
   colors[1]     = "0.1 0.6 1 0.8";
   colors[2]     = "0.1 0.6 1 0.5";
   colors[3]     = "0.1 0.6 1 0.2";

   sizes[0]      = 1.5;
   sizes[1]      = 2.5;
   sizes[2]      = 3.0;
   sizes[3]      = 3.5;

   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaCExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 10.0;
   ejectionOffset   = 2.0;
   thetaMin         = 80;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaCExplosionRingParticle";
};


datablock ParticleData(PlasmaCExplosionChunkAParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   colors[0]     = "0.1 0.6 1 0.9";
   colors[1]     = "0.1 0.6 1 0.8";
   colors[2]     = "0.1 0.6 1 0.5";
   colors[3]     = "0.1 0.6 1 0.2";
   sizes[0]      = 1;
   sizes[1]      = 1.7;
   sizes[2]      = 1.5;
   sizes[3]      = 1.5;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.9;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaCExplosionChunkAEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 5.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaCExplosionChunkAParticle";
};

datablock ParticleData(PlasmaCExplosionChunkBParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   colors[0]     = "0.1 0.6 1 0.9";
   colors[1]     = "0.1 0.6 1 0.8";
   colors[2]     = "0.1 0.6 1 0.5";
   colors[3]     = "0.1 0.6 1 0.2";

   sizes[0]      = 0.5;
   sizes[1]      = 1.7;
   sizes[2]      = 2.0;
   sizes[3]      = 3.0;

   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(PlasmaCExplosionChunkBEmitter)
{
//   lifeTimeMS = 20;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PlasmaCExplosionChunkBParticle";
};

datablock ExplosionData(PlasmaCSubExplosion2)
{
   lifetimeMS  = 600; //600
   delayMS   = 400; //400
   offset    = 6.5;
   playSpeed = 1.0;
   delayVariance = 200;

   explosionscale = "0.2 0.2 0.2";

   particleEmitter = PlasmaCExplosionBEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = PlasmaCExplosionChunkBEmitter;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "0 0.6 1 1";
   lightEndColor = "0 0.6 1 0";

};

datablock ExplosionData(PlasmaCSubExplosion1)
{
   lifetimeMS  = 400;
   delayMS   = 200; //200
   offset    = 5.0;
   playSpeed = 1.0;
   delayVariance = 200;

   explosionscale = "0.3 0.3 0.3";

   particleEmitter = PlasmaCExplosionBEmitter;
   particleDensity = 7;
   particleRadius = 0.3;

   emitter[0] = PlasmaCExplosionChunkBEmitter;
   emitter[1] = PlasmaCExplosionRingBEmitter;

   subExplosion[0] = PlasmaCSubExplosion2;
   subExplosion[1] = PlasmaCSubExplosion2;

   // Dynamic light
   lightStartRadius = 7;
   lightEndRadius = 0;
   lightStartColor = "0 0.6 1 1";
   lightEndColor = "0 0.6 1 0";
   playerBurnTime = 5000;

   debris = PlasmaCExplosionDebris1;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisPhiMin = 0;
   debrisPhiMax = 180;
   debrisNum = 4;
   debrisNumVariance = 0;
   debrisVelocity = 100;
   debrisVelocityVariance = 0.5;
   faceViewer     = false;     

};

datablock ExplosionData(PlasmaCExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionsphere1.dts";
   soundProfile = PlasmaCHit2Sound;

   lifeTimeMS = 600; //400

   particleEmitter = PlasmaCExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.5;

   emitter[0] = PlasmaCExplosionChunkAEmitter;
   emitter[1] = PlasmaCExplosionRingEmitter;

   subExplosion[0] = PlasmaCSubExplosion1;
   subExplosion[1] = PlasmaCSubExplosion1;

   faceViewer     = true;
   explosionScale = "0.4 0.4 0.4";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 15;
   lightEndRadius = 0;
   lightStartColor = "0 0.6 1 1";
   lightEndColor = "0 0.6 1 0";

   damageRadius = 5;
   radiusDamage = 90;

   impulseRadius = 3;
   impulseForce = 4000;

   playerBurnTime = 5000;
};
//arrow trail
datablock ParticleData(PlasmaCTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]     = "0 0.7 1 1";
	colors[1]     = "0.0 0.7 1 0.5";
	sizes[0]	= 0.5;
	sizes[1]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 0.3;
};
datablock ParticleEmitterData(PlasmaCTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = PlasmaCTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

AddDamageType("PlasmaC",   '<bitmap:add-ons/Weapon_PlasmaC/CI_PlasmaC> %1',    '%2 <bitmap:add-ons/Weapon_PlasmaC/CI_PlasmaC> %1',1.2,1);
datablock ProjectileData(PlasmaCProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::PlasmaC;
   radiusDamageType    = $DamageType::PlasmaC;
   impactImpulse	    	= 1000;
   verticalImpulse	  	= 1000;
   explosion          	  = PlasmaCExplosion;
   particleEmitter    	  = PlasmaCTrailEmitter;

   brickExplosionRadius = 4;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 40;
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 20;  //max volume of bricks that we can destroy if they aren't connected to the ground  

   muzzleVelocity      = 135;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 7000;
   fadeDelay           = 6000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;
   ProjectileScale = "1 1 1";

   hasLight    = false;
   lightRadius = 20;
   lightColor  = "0.0 4.0 0.0";
	
   //ui name removed
};

//////////
// item //
//////////
datablock ItemData(PlasmaCItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./PlasmaC.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Plasma Cannon";
	iconName = "./icon_PlasmaC";
	doColorShift = False;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = PlasmaCImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PlasmaCImage)
{
   // Basic Item properties
   shapeFile = "./PlasmaC.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = PlasmaCProjectile;
   projectileType = Projectile;

	//casing = PlasmaCShellDebris;
	//shellExitDir        = "1.0 -1.3 1.0";
	//shellExitOffset     = "0 0 0";
	//shellExitVariance   = 15.0;	
	//shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;
   doColorShift = false;
   colorShiftColor = PlasmaCItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = "";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= PlasmaCShot1Sound;
	stateEjectShell[2]       = False;

	stateName[3] = "Smoke";
	stateEmitterTime[3]				= 0.5;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 2.0;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";
};
